# -*- coding: utf-8 -*-

from django.db import models
from django.db.models import Q


# Organization Managers
class OwnerOrganizationManager(models.Manager):
    def get_queryset(self):
        qs = super(OwnerOrganizationManager, self).get_queryset()
        return qs.filter(organization_type__category='com', status=1)


class CustomerOrganizationManager(models.Manager):
    def get_queryset(self):
        qs = super(CustomerOrganizationManager, self).get_queryset()
        return qs.filter(organization_type__category='cus', status=1)


class SupplierOrganizationManager(models.Manager):
    def get_queryset(self):
        qs = super(SupplierOrganizationManager, self).get_queryset()
        return qs.filter(organization_type__category='sup', status=1)


class VectorOrganizationManager(models.Manager):
    def get_queryset(self):
        qs = super(VectorOrganizationManager, self).get_queryset()
        return qs.filter(organization_type__category='vec', status=1)


# Contact managers
class ContactManager(models.Manager):
    def get_queryset(self):
        return super(ContactManager, self).get_queryset()


class OwnerContactManager(models.Manager):
    def get_queryset(self):
        qs = super(OwnerContactManager, self).get_queryset()
        return qs.filter(organization__organization_type__category='com', status=1)


class CustomerContactManager(models.Manager):
    def get_queryset(self):
        qs = super(CustomerContactManager, self).get_queryset()
        return qs.filter(organization__organization_type__category='cus', status=1)


class SupplierContactManager(models.Manager):
    def get_queryset(self):
        qs = super(SupplierContactManager, self).get_queryset()
        return qs.filter(organization__organization_type__category='sup', status=1)


class WorkerContactManager(models.Manager):
    def get_queryset(self):
        qs = super(WorkerContactManager, self).get_queryset()
        return qs.filter(is_worker=True, status=1)


class VectorContactManager(models.Manager):
    def get_queryset(self):
        qs = super(VectorContactManager, self).get_queryset()
        return qs.filter(organization__organization_type__category='vec', status=1)
